"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var jsx_runtime_1 = require("@emotion/react/jsx-runtime");
var react_1 = require("@emotion/react");
var lodash_1 = require("lodash");
var Link_1 = __importDefault(require("../Link"));
var useOutlineCss_1 = __importDefault(require("../useOutlineCss"));
var Span_1 = __importDefault(require("./Span"));
var Text_1 = __importDefault(require("./Text"));
var useIsInline_1 = __importDefault(require("./useIsInline"));
var textPropsToForward = [
    "color",
    "underline",
    "weight",
    "italic",
    "children",
];
var TextLink = function (props) {
    var _a;
    var isInline = (0, useIsInline_1.default)();
    var inline = (_a = props.inline) !== null && _a !== void 0 ? _a : isInline;
    var TextComponent = inline ? Span_1.default : Text_1.default;
    var outline = (0, useOutlineCss_1.default)();
    var text = ((0, jsx_runtime_1.jsx)(TextComponent, __assign({ color: "link", underline: true }, (0, lodash_1.pick)(props, textPropsToForward))));
    if (props.asButton) {
        return ((0, jsx_runtime_1.jsx)("button", __assign({ onClick: props.handleClick, css: (0, react_1.css)({
                display: inline ? "inline-block" : "block",
                cursor: "pointer",
            }, outline) }, { children: text })));
    }
    return ((0, jsx_runtime_1.jsx)(Link_1.default, __assign({}, (0, lodash_1.omit)(props, textPropsToForward), { inline: inline }, { children: text })));
};
exports.default = TextLink;
