var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "@emotion/react/jsx-runtime";
import useTheme from "./useTheme";
import { useContext } from "react";
import { gapContext } from "./Row";
var roundDown = function (n, precision) {
    var coeff = Math.pow(10, precision);
    return Math.floor(n * coeff) / coeff;
};
var formatPercentage = function (n) { return n * 100 + "%"; };
var Column = function (_a) {
    var _b = _a.width, width = _b === void 0 ? "auto" : _b, props = __rest(_a, ["width"]);
    var size = useTheme().size;
    var gap = useContext(gapContext);
    if (typeof width === "number")
        width = formatPercentage(roundDown(width, 5));
    var flexGrow, flexBasis;
    if (width === "auto") {
        flexGrow = 0;
    }
    else if (width === "expand") {
        flexGrow = 1;
        flexBasis = 0;
    }
    else {
        flexGrow = 0;
        flexBasis = width;
    }
    return (_jsx("div", __assign({ css: {
            padding: "0 ".concat(size(gap).raw / 2, "px"),
            flexGrow: flexGrow,
            flexBasis: flexBasis,
            flexShrink: 0,
        } }, { children: props.children })));
};
export default Column;
