var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { jsx as _jsx } from "@emotion/react/jsx-runtime";
import { css } from "@emotion/react";
import { omit, pick } from "lodash";
import Link from "../Link";
import useOutlineCss from "../useOutlineCss";
import Span from "./Span";
import Text from "./Text";
import useIsInline from "./useIsInline";
var textPropsToForward = [
    "color",
    "underline",
    "weight",
    "italic",
    "children",
];
var TextLink = function (props) {
    var _a;
    var isInline = useIsInline();
    var inline = (_a = props.inline) !== null && _a !== void 0 ? _a : isInline;
    var TextComponent = inline ? Span : Text;
    var outline = useOutlineCss();
    var text = (_jsx(TextComponent, __assign({ color: "link", underline: true }, pick(props, textPropsToForward))));
    if (props.asButton) {
        return (_jsx("button", __assign({ onClick: props.handleClick, css: css({
                display: inline ? "inline-block" : "block",
                cursor: "pointer",
            }, outline) }, { children: text })));
    }
    return (_jsx(Link, __assign({}, omit(props, textPropsToForward), { inline: inline }, { children: text })));
};
export default TextLink;
